/* カード一覧 */ 
card_dict = {
    '1': {'name': '神速の魔剣士', 'category': 'ユニット', 'type': '魔人', 'attribute': '天', 'cp': '100', 'ap': '1000', 'dp': '650', 'effect': ''}, 
    '2': {'name': '水の魔道士', 'category': 'ユニット', 'type': '魔人', 'attribute': '水', 'cp': '100', 'ap': '950', 'dp': '1000', 'effect': ''}, 
    '3': {'name': 'アサシン', 'category': 'ユニット', 'type': '魔人', 'attribute': '闇', 'cp': '100', 'ap': '0', 'dp': '300', 'effect': 'この魔人が戦闘で破壊された時、自身を破壊した敵を破壊する'}, 
    '4': {'name': '魔物使い', 'category': 'ユニット', 'type': '魔人', 'attribute': '地', 'cp': '100', 'ap': '900', 'dp': '700', 'effect': 'この魔人は自分の場の魔物種族ユニットの数×250を自身のAP・DPに加算'}, 
    '5': {'name': '吸血鬼ドラキュラ', 'category': 'ユニット', 'type': '魔人', 'attribute': '闇', 'cp': '100', 'ap': '900', 'dp': '700', 'effect': 'この魔人が相手プレイヤーへ直接攻撃でダメージを与える毎に自分のLP+500'}, 
    '6': {'name': '吸血鬼カーミラ', 'category': 'ユニット', 'type': '魔人', 'attribute': '闇', 'cp': '100', 'ap': '700', 'dp': '900', 'effect': 'この魔人が相手プレイヤーへ直接攻撃でダメージを与える毎に自分のMP+50'}, 
    '7': {'name': '白い死神', 'category': 'ユニット', 'type': '魔人', 'attribute': '光', 'cp': '150', 'ap': '1250', 'dp': '900', 'effect': ''}, 
    '8': {'name': 'ダークチャリオット', 'category': 'ユニット', 'type': '魔人', 'attribute': '闇', 'cp': '150', 'ap': '1200', 'dp': '1250', 'effect': ''}, 
    '9': {'name': '竜の守護者', 'category': 'ユニット', 'type': '魔人', 'attribute': '火', 'cp': '200', 'ap': '1350', 'dp': '1350', 'effect': 'この魔人が守備表示で場から墓地へ行った時、【No055 ベビードラゴン】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '10': {'name': '忠義の騎士ガウェイン', 'category': 'ユニット', 'type': '魔人', 'attribute': '火', 'cp': '200', 'ap': '1500', 'dp': '1150', 'effect': ''}, 
    '11': {'name': '湖の騎士ランスロット', 'category': 'ユニット', 'type': '魔人', 'attribute': '水', 'cp': '200', 'ap': '1450', 'dp': '1500', 'effect': ''}, 
    '12': {'name': 'アーサー王', 'category': 'ユニット', 'type': '魔人', 'attribute': '光', 'cp': '250', 'ap': '1350', 'dp': '1250', 'effect': 'この魔人がユニットを破壊する毎に擬似マジック扱いの【No157 ナイトの紋章】を自分の場に擬似設置'}, 
    '13': {'name': 'ソロモン王', 'category': 'ユニット', 'type': '魔人', 'attribute': '光', 'cp': '250', 'ap': '300', 'dp': '300', 'effect': 'この魔人が守備表示から攻撃表示になる毎に デッキの一番上の悪魔種族ユニットを攻撃表示・行動不能状態で自分の場に召喚'}, 
    '14': {'name': '炎の巨人スルト', 'category': 'ユニット', 'type': '魔人', 'attribute': '火', 'cp': '300', 'ap': '1800', 'dp': '1400', 'effect': 'この魔人は場の属性が「火」に変更された時、擬似マジック扱いの【No143 未完のキューブ】を自分の場に擬似設置'}, 
    '15': {'name': 'メイドナイト', 'category': 'ユニット', 'type': '魔人', 'attribute': '火', 'cp': '150', 'ap': '800', 'dp': '600', 'effect': 'この魔人が召喚された時、デッキの一番上の継続魔法をドロー'}, 
    '16': {'name': 'メイドスイーパー', 'category': 'ユニット', 'type': ' 魔人', 'attribute': '水', 'cp': '150', 'ap': '800', 'dp': '600', 'effect': 'この魔人が召喚された時、デッキの一番上の属性魔法をドロー'}, 
    '17': {'name': 'メイドクラッシャー', 'category': 'ユニット', 'type': '魔人', 'attribute': '地', 'cp': '150', 'ap': '1050', 'dp': '850', 'effect': 'この魔人が召喚された時、デッキの一番上の装備魔法をドロー'}, 
    '18': {'name': 'メイドウィッチ', 'category': 'ユニット', 'type': '魔人', 'attribute': '天', 'cp': '150', 'ap': '1050', 'dp': '850', 'effect': 'この魔人が召喚された時、デッキの一番上の単発魔法をドロー'}, 
    '19': {'name': '化身ナラシンハ', 'category': 'ユニット', 'type': '魔人', 'attribute': '地', 'cp': '150', 'ap': '1100', 'dp': '700', 'effect': 'この魔人は自分のドロー毎に自身の基礎AP・基礎DP+100'}, 
    '20': {'name': '化身ヴァーマナ', 'category': 'ユニット', 'type': '魔人', 'attribute': '地', 'cp': '150', 'ap': '1350', 'dp': '1350', 'effect': 'この魔人が場に在る時、自分のドローフェイズにドロー可能な枚数が1枚増加'}, 
    '21': {'name': '化身パラシュラーマ', 'category': 'ユニット', 'type': '魔人', 'attribute': '光', 'cp': '200', 'ap': '1150', 'dp': '1450', 'effect': 'この魔人が召喚されたとき、後方に【No 197 防御攻撃の極意】を擬似設置、後方にマジックがあるなら自分は1枚ドロー'}, 
    '22': {'name': '化身ラーマ', 'category': 'ユニット', 'type': '魔人', 'attribute': '火', 'cp': '200', 'ap': '1200', 'dp': '1200', 'effect': 'この魔人が攻守を変更する毎に自分の基礎AP・基礎DP+100、更に自分は1枚ドロー'}, 
    '23': {'name': '化身クリシュナ', 'category': 'ユニット', 'type': '魔人', 'attribute': '闇', 'cp': '250', 'ap': '1700', 'dp': '1500', 'effect': 'この魔人は敵を破壊する毎に自分のLP+1000'}, 
    '24': {'name': '化身バララーマ', 'category': 'ユニット', 'type': '魔人', 'attribute': '光', 'cp': '250', 'ap': '1350', 'dp': '1000', 'effect': 'この魔人は手札が多いほどAP・DPが増加（手札1枚につきAP・DP+100）'}, 
    '25': {'name': '化身カルキ', 'category': 'ユニット', 'type': '魔人', 'attribute': '光', 'cp': '300', 'ap': '1700', 'dp': '1700', 'effect': 'この魔人が召喚された時、自分は2枚ドロー'}, 
    '26': {'name': 'ゴブリン', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '100', 'ap': '950', 'dp': '1000', 'effect': ''}, 
    '27': {'name': 'ペリュトン', 'category': 'ユニット', 'type': '魔物', 'attribute': '水', 'cp': '100', 'ap': '1000', 'dp': '650', 'effect': ''}, 
    '28': {'name': 'アーコル', 'category': 'ユニット', 'type': '魔物', 'attribute': '天', 'cp': '100', 'ap': '900', 'dp': '700', 'effect': 'この魔物は自分の場の自身以外の【No028 アーコル】の数×200を自身のAP・DPに加算'}, 
    '29': {'name': 'ガマゴン', 'category': 'ユニット', 'type': '魔物', 'attribute': '水', 'cp': '100', 'ap': '500', 'dp': '700', 'effect': 'この魔物が場に在る時、自分のターン開始毎に擬似ユニット扱いの【No029 ガマゴン】を擬似召喚 ※攻守・行動状態は継承'}, 
    '30': {'name': 'アルラウネ', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '100', 'ap': '800', 'dp': '900', 'effect': 'この魔物が戦闘で破壊された時、全ての場のDP1000未満のユニットを全て破壊'}, 
    '31': {'name': 'ハーピィ', 'category': 'ユニット', 'type': '魔物', 'attribute': '天', 'cp': '100', 'ap': '950', 'dp': '950', 'effect': 'この魔物は戦闘によるダメージを受けない'}, 
    '32': {'name': 'アラクネ', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '150', 'ap': '1200', 'dp': '1250', 'effect': ''}, 
    '33': {'name': 'グリフォン', 'category': 'ユニット', 'type': '魔物', 'attribute': '天', 'cp': '150', 'ap': '1250', 'dp': '900', 'effect': ''}, 
    '34': {'name': '化身マツヤ', 'category': 'ユニット', 'type': '魔物', 'attribute': '水', 'cp': '150', 'ap': '1150', 'dp': '1150', 'effect': 'この魔物が場に在る時、場の属性が「水」であれば、自身のAP・DP+200'}, 
    '35': {'name': '化身ヴァラーハ', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '150', 'ap': '1150', 'dp': '1050', 'effect': 'この魔物が場に在る時、自分のターン開始毎に自身の基礎AP+150'}, 
    '36': {'name': 'フレアモンスター', 'category': 'ユニット', 'type': '魔物', 'attribute': '火', 'cp': '150', 'ap': '0', 'dp': '0', 'effect': 'この魔物は攻守を変更した時墓地へ行き、【No086 智天使ハニエル】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '37': {'name': 'アクアモンスター', 'category': 'ユニット', 'type': '魔物', 'attribute': '水', 'cp': '150', 'ap': '0', 'dp': '0', 'effect': 'この魔物は攻守を変更した時墓地へ行き、【No087 智天使カフジエル】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '38': {'name': 'アースモンスター', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '150', 'ap': '0', 'dp': '0', 'effect': 'この魔物は攻守を変更した時墓地へ行き、【No088 智天使アズリエル】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '39': {'name': 'スカイモンスター', 'category': 'ユニット', 'type': '魔物', 'attribute': '天', 'cp': '150', 'ap': '0', 'dp': '0', 'effect': 'この魔物は攻守を変更した時墓地へ行き、【No089 智天使アニエル】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '40': {'name': 'フレアバード', 'category': 'ユニット', 'type': '魔物', 'attribute': '火', 'cp': '150', 'ap': '1250', 'dp': '850', 'effect': 'この魔物は自分の場に【No041 アクアバード】か【No042 サンダーバード】が在る時、自身のAP・DP+250'}, 
    '41': {'name': 'アクアバード', 'category': 'ユニット', 'type': '魔物', 'attribute': '水', 'cp': '150', 'ap': '1150', 'dp': '1250', 'effect': 'この魔物は自分の場に【No040 フレアバード】か【No042 サンダーバード】が在る時、自身のAP・DP+250'}, 
    '42': {'name': 'サンダーバード', 'category': 'ユニット', 'type': '魔物', 'attribute': '天', 'cp': '150', 'ap': '1200', 'dp': '1200', 'effect': 'この魔物は自分の場に【No040 フレアバード】か【No041 アクアバード】が在る時、自身のAP・DP+250'}, 
    '43': {'name': 'トレント', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '200', 'ap': '1400', 'dp': '1400', 'effect': 'この魔物が場に在る時、自分のLPが回復 する毎に回復したLP÷10の値で自分のMPを回復 ※重複効果なし'}, 
    '44': {'name': '冥府の番犬ガルム', 'category': 'ユニット', 'type': '魔物', 'attribute': '闇', 'cp': '200', 'ap': '1400', 'dp': '1400', 'effect': 'この魔物が場に在る時、場の属性が「闇」であれば、自身のAP・DP+200'}, 
    '45': {'name': '合成獣キマイラ', 'category': 'ユニット', 'type': '魔物', 'attribute': '闇', 'cp': '200', 'ap': '1450', 'dp': '1500', 'effect': ''}, 
    '46': {'name': '蟻獅子ミルメコレオ', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '200', 'ap': '2000', 'dp': '1000', 'effect': 'この魔物は自分のターン 開始時に破壊される'}, 
    '47': {'name': '聖鳥ガルーダ', 'category': 'ユニット', 'type': '魔物', 'attribute': '天', 'cp': '200', 'ap': '1500', 'dp': '1150', 'effect': ''}, 
    '48': {'name': '魔獣リヴァイアサン', 'category': 'ユニット', 'type': '魔物', 'attribute': '水', 'cp': '250', 'ap': '2000', 'dp': '1650', 'effect': 'この魔物が場に在る時、自分のターン開始毎に自分のMP-50'}, 
    '49': {'name': '魔獣ベヒーモス', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '250', 'ap': '1950', 'dp': '2000', 'effect': 'この魔物が場に在る時、自分のターン開始毎に自分のLP-500'}, 
    '50': {'name': '魔狼フェンリル', 'category': 'ユニット', 'type': '魔物', 'attribute': '闇', 'cp': '250', 'ap': '1500', 'dp': '1700', 'effect': 'この魔物は敵を破壊する毎に自分のMP+100'}, 
    '51': {'name': '1stプラント', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '100', 'ap': '850', 'dp': '550', 'effect': 'この魔物は1ターン後の自分のターン開始時に墓地へ行き、【No052 2ndプラント】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '52': {'name': '2ndプラント', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '150', 'ap': '1100', 'dp': '800', 'effect': 'この魔物は1ターン後の自分 のターン開始時に墓地へ行き、【No053 3rdプラント】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '53': {'name': '3rdプラント', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '200', 'ap': '1350', 'dp': '1050', 'effect': 'この魔物は1ターン後の自分のターン開始時に墓地へ行き、【No054 4thプラント】を自分の場に擬似召喚 ※攻守・行動状態は継承'},
    '54': {'name': '4thプラント', 'category': 'ユニット', 'type': '魔物', 'attribute': '地', 'cp': '250', 'ap': '1500', 'dp': '1200', 'effect': 'この魔物が場に在る時、自分のターン開始毎に【No051 1stプラント】を自分の場に擬似召喚 ※攻守・行動状態は継承'},
    '55': {'name': 'ベビードラゴン', 'category': 'ユニット', 'type': '竜', 'attribute': '天', 'cp': '100', 'ap': '950', 'dp': '950', 'effect': 'この竜は後方にマジックが設置された時 、そのマジックを破壊し、破壊されたマジックのCP×4の値を自身の基礎AP･基礎DPに加算'}, 
    '56': {'name': 'ワイバーン', 'category': 'ユニット', 'type': '竜', 'attribute': '天', 'cp': '100', 'ap': '1000', 'dp': '650', 'effect': ''}, 
    '57': {'name': 'バジリスク', 'category': 'ユニット', 'type': '竜', 'attribute': '火', 'cp': '100', 'ap': '950', 'dp': '1000', 'effect': ''}, 
    '58': {'name': 'フェアリードラゴン', 'category': 'ユニット', 'type': '竜', 'attribute': '天', 'cp': '100', 'ap': '800', 'dp': '800', 'effect': 'この竜が相手プレイヤーへ直接攻撃でダメージを与える毎に自分は1枚ドロー'}, 
    '59': {'name': 'フレイム・サーペント', 'category': 'ユニット', 'type': '竜', 'attribute': '火', 'cp': '150', 'ap': '1200', 'dp': '1250', 'effect': ''}, 
    '60': {'name': 'シー・サーペント', 'category': 'ユニット', 'type': '竜', 'attribute': '水', 'cp': '150', 'ap': '1250', 'dp': '900', 'effect': ''}, 
    '61': {'name': 'フヴェルゲルミルの毒蛇', 'category': 'ユニット', 'type': '竜', 'attribute': '闇', 'cp': '150', 'ap': '1100', 'dp': '1100', 'effect': 'この竜は場の属性が「闇」に変更された時に墓地へ行き、【No072 毒蛇の王ニーズホッグ】を自分の場に擬似召喚 ※攻守・行動状態は継承'}, 
    '62': {'name': '環蛇ウロボロス', 'category': 'ユニット', 'type': '竜', 'attribute': '光', 'cp': '150', 'ap': '1050', 'dp': '1050', 'effect': 'この竜が守備表示で召喚された時、【No166 時の砂】を自分の場に擬似設置'}, 
    '63': {'name': '化身クールマ', 'category': 'ユニット', 'type': '竜', 'attribute': '水', 'cp': '150', 'ap': '950', 'dp': '1250', 'effect': 'この竜が場に在る時、自分のターン開始毎に自身の基礎DP+150'}, 
    '64': {'name': 'グリーンドラゴン', 'category': 'ユニット', 'type': '竜', 'attribute': '地', 'cp': '200', 'ap': '1450', 'dp': '1500', 'effect': ''}, 
    '65': {'name': 'ブルードラゴン', 'category': 'ユニット', 'type': '竜', 'attribute': '水', 'cp': '200', 'ap': '1500', 'dp': '1150', 'effect': ''}, 
    '66': {'name': 'ゴールドドラゴン', 'category': 'ユニット', 'type': '竜', 'attribute': '天', 'cp': '200', 'ap': '1150', 'dp': '1250', 'effect': 'この竜が攻守を変更する毎に自身の基礎AP・基礎DP+100、さらに自分のMP+50'}, 
    '67': {'name': 'ドラゴンゾンビ', 'category': 'ユニット', 'type': '竜', 'attribute': '地', 'cp': '200', 'ap': '1650', 'dp': '500', 'effect': 'この竜が場に在る時、自分のターン開始毎に自身の基礎AP-100'}, 
    '68': {'name': 'アンデッドドラゴン', 'category': 'ユニット', 'type': '竜', 'attribute': '地', 'cp': '200', 'ap': '1000', 'dp': '2000', 'effect': 'この竜が場に在る時、自分のターン開始毎に自身の基礎DP-100'}, 
    '69': {'name': '邪竜タラスクス', 'category': 'ユニット', 'type': '竜', 'attribute': '闇', 'cp': '200', 'ap': '1200', 'dp': '1200', 'effect': 'この竜が攻守を変更する毎に自身の基礎AP・基礎DP+200'}, 
    '70': {'name': '邪竜ファフニール', 'category': 'ユニット', 'type': '竜', 'attribute': '火', 'cp': '200', 'ap': '1000', 'dp': '1000', 'effect': 'この竜はLPが回復する毎に回復したLP÷2の値を自身の基礎AP・基礎DPに加算'}, 
    '71': {'name': '九頭竜ヒュドラ', 'category': 'ユニット', 'type': '竜', 'attribute': '火', 'cp': '250', 'ap': '0', 'dp': '0', 'effect': 'この竜は攻撃表示で破壊された時、守備表示で場に残る'}, 
    '72': {'name': '毒蛇の王ニーズホッグ', 'category': 'ユニット', 'type': '竜', 'attribute': '闇', 'cp': '250', 'ap': '1600', 'dp': '1600', 'effect': 'この竜は敵を破壊する毎に自分は2枚ドロー'}, 
    '73': {'name': '世界蛇ヨルムンガンド', 'category': 'ユニット', 'type': '竜', 'attribute': '水', 'cp': '250', 'ap': '1500', 'dp': '1700', 'effect': 'この竜が召喚された時、自分のMP+50'}, 
    '74': {'name': '冥府の大蛇ファラク', 'category': 'ユニット', 'type': '竜', 'attribute': '地', 'cp': '300', 'ap': '1600', 'dp': '1600', 'effect': 'この竜は場の属性が変更される毎に自分のMP+150'}, 
    '75': {'name': '皇竜バハムート', 'category': 'ユニット', 'type': '竜', 'attribute': '火', 'cp': '300', 'ap': '1850', 'dp': '1500', 'effect': 'この竜は自分の場に存在する火属性ユニットの数×50を減算したCPで召喚できる'}, 
    '76': {'name': '守護天使', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '100', 'ap': '500', 'dp': '1000', 'effect': 'この天使が場に在る時、自分の場のユニットは守備表示のまま攻撃できる'}, 
    '77': {'name': 'エンジェル', 'category': 'ユニット', 'type': '天使', 'attribute': ' 光', 'cp': '100', 'ap': '950', 'dp': '1000', 'effect': ''}, 
    '78': {'name': 'アークエンジェル', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '100', 'ap': '1000', 'dp': '650', 'effect': ''}, 
    '79': {'name': 'プリンシパリティ', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '100', 'ap': '500', 'dp': '800', 'effect': 'この天使が場に在る時、自分の場の全てのユニッ トのAP・DP+200'}, 
    '80': {'name': 'パワー', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '150', 'ap': '1200', 'dp': '1250', 'effect': ''}, 
    '81': {'name': 'ヴァーチャー', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '150', 'ap': '1250', 'dp': '900', 'effect': ''}, 
    '82': {'name': 'ドミニオン', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '150', 'ap': '1000', 'dp': '900', 'effect': 'この天使が攻守を変更する毎に自身の基礎AP・基礎DP+100、更に自分のLP+500'}, 
    '83': {'name': 'ソロネ', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '200', 'ap': '1450', 'dp': '1500', 'effect': ''}, 
    '84': {'name': 'ケルプ', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '200', 'ap': '1500', 'dp': '1150', 'effect': ''}, 
    '85': {'name': 'セラフ', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '200', 'ap': '1450', 'dp': '1250', 'effect': 'この天使が場に在る時、自分のターン開始毎に自分のLP+500'}, 
    '86': {'name': '智天使ハニエル', 'category': 'ユニット', 'type': '天使', 'attribute': '火', 'cp': '250', 'ap': '1600', 'dp': '1250', 'effect': 'この天使が召喚された時、場の属性を「火」に変更 ※擬似 召喚時は効果なし'}, 
    '87': {'name': '智天使カフジエル', 'category': 'ユニット', 'type': '天使', 'attribute': '水', 'cp': '250', 'ap': '1550', 'dp': '1600', 'effect': 'この天使が召喚された時、場の属性 を「水」に変更 ※擬似召喚時は効果なし'}, 
    '88': {'name': '智天使アズリエル', 'category': 'ユニット', 'type': '天使', 'attribute': '地', 'cp': '250', 'ap': '1600', 'dp': '1250', 'effect': 'この天使が召喚された時、場の属性を「地」に変更 ※擬似召喚時は効果なし'}, 
    '89': {'name': '智天使アニエル', 'category': 'ユニット', 'type': '天使', 'attribute': '天', 'cp': '250', 'ap': '1550', 'dp': '1600', 'effect': 'この天使が召喚された時、場の属性を「天」に変更 ※擬似召喚時は効果なし'}, 
    '90': {'name': '熾天使ウリエル', 'category': 'ユニット', 'type': '天使', 'attribute': '地', 'cp': '250', 'ap': '1200', 'dp': '1250', 'effect': 'この天使はLPが高いほどAP・DPが増加（LP1000につきAP・DP+100）'}, 
    '91': {'name': '熾天使ラファエル', 'category': 'ユニット', 'type': '天使', 'attribute': '天', 'cp': '250', 'ap': '1650', 'dp': '1250', 'effect': 'この天使が召喚された時、自分のLP+1000'}, 
    '92': {'name': '熾天使ガブリエル', 'category': 'ユニット', 'type': '天使', 'attribute': '水', 'cp': '250', 'ap': '1650', 'dp': '1700', 'effect': 'この天使が場に在る時、自分のLPの減少が1/2減少する ※重複効果なし'}, 
    '93': {'name': '熾天使メタトロン', 'category': 'ユニット', 'type': '天使', 'attribute': '光', 'cp': '300', 'ap': '1800', 'dp': '1850', 'effect': 'この天使が召喚された時、場の属性を「光」に変更'}, 
    '94': {'name': '天使長ミカエル', 'category': 'ユニット', 'type': '天使', 'attribute': '火', 'cp': '300', 'ap': '1750', 'dp': '1950', 'effect': 'この天使が場に在る時、自分のターン開始毎に自分のMP+50'}, 
    '95': {'name': 'ガーゴイル', 'category': 'ユニット', 'type': '悪魔', 'attribute': '地', 'cp': '100', 'ap': '800', 'dp': '800', 'effect': 'この悪魔がセットフェイズに召喚された時、後方に在るマジックの裏表を反転させる'}, 
    '96': {'name': 'アークデーモン', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '100', 'ap': '1000', 'dp': '300', 'effect': 'この悪魔が召喚された時、デッキの一番上のマジックをデッキの一番上に持ってくる'}, 
    '97': {'name': 'ミソパエス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '100', 'ap': '950', 'dp': '1000', 'effect': ''}, 
    '98': {'name': 'ヒュポクトニア', 'category': 'ユニット', 'type': '悪魔', 'attribute': '火', 'cp': '100', 'ap': '1000', 'dp': '650', 'effect': ''}, 
    '99': {'name': 'ヒュドライア', 'category': 'ユニット', 'type': '悪魔', 'attribute': '水', 'cp': '150', 'ap': '1200', 'dp': '1250', 'effect': ''}, 
    '100': {'name': 'クトニア', 'category': 'ユニット', 'type': '悪魔', 'attribute': '地', 'cp': '150', 'ap': '1250', 'dp': '900', 'effect': ''}, 
    '101': {'name': 'アエリア', 'category': 'ユニット', 'type': '悪魔', 'attribute': '天', 'cp': '150', 'ap': '1450', 'dp': '1500', 'effect': ''}, 
    '102': {'name': 'レリウーリア', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '150', 'ap': '1500', 'dp': '1150', 'effect': ''}, 
    '103': {'name': '不定形の伯爵ビフロンス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '150', 'ap': '1450', 'dp': '1100', 'effect': 'この悪魔が召喚された時、自分の手札の左側2枚を墓地に送る'}, 
    '104': {'name': '戦争の伯爵ハルファス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '150', 'ap': '1400', 'dp': '1450', 'effect': 'この悪魔が 召喚された時、自分のLP-1000'}, 
    '105': {'name': '不死の侯爵フェネクス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '火', 'cp': '200', 'ap': '1450', 'dp': '1200', 'effect': 'この悪魔は破壊さ れた時、自分の手札に戻る'}, 
    '106': {'name': '不和の侯爵アンドラス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '200', 'ap': '1250', 'dp': '850', 'effect': 'この悪魔は自分の墓地 の悪魔種族ユニットの数×100を自身のAP・DPに加算'}, 
    '107': {'name': '異相の侯爵ダンタリアン', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '200', 'ap': '1400', 'dp': '1400', 'effect': 'この悪魔が場に在る時、自分のターン開始時に相手のLP-250'}, 
    '108': {'name': '音楽の公爵ムルムル', 'category': 'ユニット', 'type': '悪魔', 'attribute': '天', 'cp': '250', 'ap': '1400', 'dp': '1700', 'effect': 'この悪魔は自分のターン開始時に自動で攻撃表示に、自分のターン終了時に自動で守備表示になる'}, 
    '109': {'name': '大公メフィストフェレス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '250', 'ap': '800', 'dp': '800', 'effect': 'この悪魔の後方に在るマジックの発動にはチェーンできない'}, 
    '110': {'name': '恐怖公アスタロス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '地', 'cp': '250', 'ap': '1200', 'dp': '1250', 'effect': 'この悪魔はLPが低いほどAP・DPが増加（LP6000からLP-1000につきAP・DP+200）'}, 
    '111': {'name': '破壊の公爵アスモデウス', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '250', 'ap': '1250', 'dp': '900', 'effect': 'この悪魔は手札が少ないほどAP・DPが増加（手札5枚から手札-1につきAP・DP+200）'}, 
    '112': {'name': '悪徳の王ベリアル', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '300', 'ap': '1850', 'dp': '1500', 'effect': 'この悪魔が召喚された時、場の属性を「闇」に変更'}, 
    '113': {'name': '蝿の王ベルゼバブ', 'category': 'ユニット', 'type': '悪魔', 'attribute': '天', 'cp': '300', 'ap': '1750', 'dp': '1350', 'effect': 'この悪魔は自分の墓地の悪魔の数×20を減算したCPで召喚できる'}, 
    '114': {'name': '大魔王ルシファー', 'category': 'ユニット', 'type': '悪魔', 'attribute': '闇', 'cp': '300', 'ap': '1700', 'dp': '1500', 'effect': 'この悪魔が召喚された時、デッキの一番上がCP150以下のマジックであれば、そのマジックを設置'}, 
    '115': {'name': '夜叉神ダーキニー', 'category': 'ユニット', 'type': '神', 'attribute': '闇', 'cp': '200', 'ap': '1350', 'dp': '1350', 'effect': 'この神は敵を破壊する毎に自身の基礎AP+200・基礎DP+200'}, 
    '116': {'name': '戦女神ヴァルキリー', 'category': 'ユニット', 'type': '神', 'attribute': '光', 'cp': '200', 'ap': '1450', 'dp': '1200', 'effect': 'この神が召喚された時、墓地のユニットを上から順に可能な限り手札に戻す'}, 
    '117': {'name': '冥府の神ヘル', 'category': 'ユニット', 'type': '神', 'attribute': '闇', 'cp': '250', 'ap': '1100', 'dp': '1100', 'effect': 'この神が召喚された時、墓地の一番上のCP200以下のユニットを攻撃表示・行動可能状態で自分の場に召喚'}, 
    '118': {'name': '山の神パールヴァティー', 'category': 'ユニット', 'type': '神', 'attribute': '地', 'cp': '300', 'ap': '1800', 'dp': '1600', 'effect': 'この神が破壊された時、自分のLP+1000'}, 
    '119': {'name': '美の神ラクシュミー', 'category': 'ユニット', 'type': '神', 'attribute': '水', 'cp': '300', 'ap': '1600', 'dp': '1800', 'effect': 'この神が破壊された時、自分のMP+100'}, 
    '120': {'name': '雷神トール', 'category': 'ユニット', 'type': '神', 'attribute': '天', 'cp': '300', 'ap': '1900', 'dp': '1550', 'effect': 'この神は相手の場にユニットがいても、1/2のAPで直接攻撃可能'}, 
    '121': {'name': '邪神ロキ', 'category': 'ユニット', 'type': '神', 'attribute': '闇', 'cp': '300', 'ap': '1500', 'dp': '1100', 'effect': 'この 神は自分の墓地のユニットの数×15を減算したCPで召喚でき、自分の墓地のユニットの数×75を自身のAP・DPに加算'}, 
    '122': {'name': '破壊神シヴァ', 'category': 'ユニット', 'type': '神', 'attribute': '地', 'cp': '400', 'ap': '1500', 'dp': '1100', 'effect': 'この神が攻守を変更する毎に相手の場のユニットを全て破壊'}, 
    '123': {'name': '維持神ヴィシュヌ', 'category': 'ユニット', 'type': '神', 'attribute': '天', 'cp': '400', 'ap': '2300', 'dp': '2300', 'effect': 'この神が場に在る時、自分のLPの減少を無効化'}, 
    '124': {'name': '創造神ブラフマー', 'category': 'ユニット', 'type': '神', 'attribute': '光', 'cp': '400', 'ap': '1600', 'dp': '1600', 'effect': 'この神が召喚された時、【No159 召喚解除】を自分の場に擬似設置'}, 
    '125': {'name': '主神オーディン', 'category': 'ユニット', 'type': '神', 'attribute': '光', 'cp': '400', 'ap': '1600', 'dp': '1600', 'effect': 'この神が場に在る時、自分の手札・墓地のマジックのCP-50'}, 
    '126': {'name': '悪神アンラマンユ', 'category': 'ユニット', 'type': '神', 'attribute': '闇', 'cp': '400', 'ap': '1400', 'dp': '1500', 'effect': 'この神が場に在る時、自分のターン開始毎にデッキの一番上のマジックを場に設置'}, 
    '127': {'name': '善神アフラマズダ', 'category': 'ユニット', 'type': '神', 'attribute': '光', 'cp': '0', 'ap': '0', 'dp': '0', 'effect': 'この神が召喚された時、自分の場のユニットを全て破壊し、破壊したユニットの基礎AP・基礎DPの合計を自身の基礎AP・基礎DPとする'}, 
    '128': {'name': '暁の神ケプリ', 'category': 'ユニット', 'type': '神', 'attribute': '光', 'cp': '400', 'ap': '2300', 'dp': '2300', 'effect': 'この神は自分のターン開始時に墓地へ行き、【No129 太陽神ラー】を自分の場に擬似召喚し、自分のLP+1000 ※攻守・行動状態は継承'}, 
    '129': {'name': '太陽神ラー', 'category': 'ユニット', 'type': '神', 'attribute': '天', 'cp': '400', 'ap': '2300', 'dp': '2300', 'effect': 'この神は自分のターン開始時に墓地へ行き、【No130 宵の神アトゥム】を自分の場に擬似召喚し、自分のMP+100 ※攻守・行動状態は継承'}, 
    '130': {'name': '宵の神アトゥム', 'category': 'ユニット', 'type': '神', 'attribute': '闇', 'cp': '400', 'ap': '2300', 'dp': '2300', 'effect': 'この神は自分のターン開始時に墓地へ行き、【No128 暁の神ケプリ】を自分の場に擬似召喚し、自分は2枚ドロー ※攻守・行動状態は継承'}, 
    '131': {'name': '癒しの聖水', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のLP+1000'}, 
    '132': {'name': '癒しの旋風', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '自分のLP+3000'}, 
    '133': {'name': '命削りの水', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '選択した相手のLP-500'}, 
    '134': {'name': '命削りの風', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '選択 した相手のLP-1500'}, 
    '135': {'name': '精神の秘箱', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のMP+100'}, 
    '136': {'name': '精神の宝箱', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '自分のMP+300'}, 
    '137': {'name': '心削りの石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '選択した相手のMP-100'}, 
    '138': {'name': '心削りの杭', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '選択した相手のMP-300'}, 
    '139': {'name': '補充の緑泡', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分は2枚ドロー'}, 
    '140': {'name': '補充の赤泡', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '選択した相手の手札の左側の3枚を墓地に送る'}, 
    '141': {'name': '抹殺の緑風', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '選択した相手の手札の左側の1枚を墓地に送る'}, 
    '142': {'name': '抹殺の赤風', 'category': 'マジック', 'type': '単 発', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '選択した相手の手札の左側の3枚を墓地に送る'}, 
    '143': {'name': '未完のキューブ', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '相手の場のユニットを1体選択して破壊'}, 
    '144': {'name': '封魔石の欠片', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '相手の場のマジックを1つ選択して破壊'}, 
    '145': {'name': '破壊のキューブ', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '300', 'ap': '', 'dp': '', 'effect': '相手 の場のユニットを全て破壊'}, 
    '146': {'name': '封魔石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '300', 'ap': '', 'dp': '', 'effect': '相手の場のマジックを全て破壊'}, 
    '147': {'name': '生命の滅亡', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '全ての場の全てのユニットを破壊'}, 
    '148': {'name': '魔力の滅亡', 'category': ' マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '全ての場の全てのマジックを破壊'}, 
    '149': {'name': '攻撃強制の原石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '全ての場のユニットから1体選択し、選択したユニットを攻撃表示に変更'}, 
    '150': {'name': '守備強制の原石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '全ての場のユニットから1体選択し、選択したユニットを守備表示に変更'}, 
    '151': {'name': 'AP⇔DP', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '全ての場からユニットを1体選択し、選択したユニットの基礎APと基礎DPを交換'}, 
    '152': {'name': '速攻反転', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '全ての場からユニットを1体選択し、選択したユニットの攻守を反転させ、更に【No151 AP⇔DP】を擬似設置'}, 
    '153': {'name': '攻撃強制の輝石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場の全てのユニットを攻撃表示に変更'}, 
    '154': {'name': '守備強制の輝石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場の全てのユニットを守備表示に変更'}, 
    '155': {'name': 'AP⇔DP(全)', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場の全てのユニットの基礎APと基礎DPを交換'}, 
    '156': {'name': '光速反転', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の場の全てのユニットの攻守を反転させ、更に【No155 AP⇔DP(全)】を一枚、擬似設置'}, 
    '157': {'name': 'ナイトの紋章', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の場の行動不能のユニットを1体選択して行動可能に変更 ※同盟者も対象'}, 
    '158': {'name': 'ソーマの烙印', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '相手の場の行動可能なユニットを1体選択して行動不能に変更'}, 
    '159': {'name': '召喚解除', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の場のユニットを全て手札に戻し、戻したCP分のMPを回復 ※手札に空きが無ければ戻れない ※擬似召喚されたカードは対象外'}, 
    '160': {'name': '魔法解除', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の場のマジックを全て手札に戻し、戻したCP分のMPを回復 ※手札に空きが無ければ戻れない ※擬似召喚されたカードは対象外'}, 
    '161': {'name': '生体転送', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のユニットを全て亜空間へ転送し、自分のターン開始時に場に戻す'}, 
    '162': {'name': '魔道転送', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のマジックを全て亜空間へ転送し、自分のターン開始時に場に戻す'}, 
    '163': {'name': '生命吸収', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のユニットを全て破壊し、破壊したユニットのCP分のMPを回復'}, 
    '164': {'name': '魔力吸収', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のマジックを全て破壊し、破壊したマジックのCP分のMPを回復'}, 
    '165': {'name': '生贄の儀式', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のユニットを全て破壊し、自分 の手札から選択したユニットを破壊したユニットの合計CPを減算したCPで召喚'}, 
    '166': {'name': '時の砂', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の場を1ターン経過させる ※通常のMP回復とドロー、行動状態回復は行われない'}, 
    '167': {'name': '神の砂時計', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '自分の場を3ターン経過させる ※通常のMP回復とドロー、行動状態回復は行われない'}, 
    '168': {'name': '魔力の石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '自分のLPを3000消費し、MPを+300'}, 
    '169': {'name': '契約の石', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のデ ッキからマジックを5枚墓地に送ってMP+150'}, 
    '170': {'name': '希望の月', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の手札を全て墓地に送り 、墓地に送った枚数×50のMPを回復'}, 
    '171': {'name': '希望の光', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の手札の基礎CP150以下のユニット を全て墓地に送り、墓地に送った枚数をドロー'}, 
    '172': {'name': '希望の雷', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '自分の手札を全て墓地に送り、カードを5枚ドロー'}, 
    '173': {'name': '援軍要請の蒼玉', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のデッキから選択したユニットをドロー ※カードはNo順に表示される'}, 
    '174': {'name': '支援要請の紅玉', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のデッキから選択したマジックをドロー※カードはNo順に表示される'}, 
    '175': {'name': '王の狩り', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '選択した相手の場に【No028 アーコル】を攻撃表示で3体、自分の場に【No012 アーサー王】を攻撃表示で1体、擬似召喚'}, 
    '176': {'name': '魔物の香水', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の場に【No028 アーコル】を攻撃表示で1体、擬似召喚'}, 
    '177': {'name': '邪竜の襲来', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '選択した相手の場に【No002 水の魔道士】を攻撃表示で2体、自分の場に【No070 邪竜ファフニール】を攻撃表示で1体、擬似召喚'}, 
    '178': {'name': '守護霊の顕現', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '全てのプレイヤーの場に【No076 守護天使】を守備表示で1体ずつ、擬似ユニット扱いで召喚'}, 
    '179': {'name': '恐怖公の召喚', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '自分のLPを3000消費し、自分の場に【No110 恐怖公アスタロス】を攻撃表示で1体、擬似召喚'}, 
    '180': {'name': '夜叉神の竜殺し', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '選択した相手の場に【No057 バジリスク】を攻撃表示で2体、自分の場に【No115 夜叉神ダーキニー】を攻撃表示で1体、擬似召喚'}, 
    '181': {'name': '復活の蓮華門', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の墓地からユニットを1体選択し、自分の場に召喚 ※CP分のMPを消費'}, 
    '182': {'name': '降魔の蓮華門', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の墓地からマジックを1つ選択し、自分 の場に設置 ※CP分のMPを消費'}, 
    '183': {'name': '手引きの果実', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択したユニットを 基礎CPの1/10増加したCPで召喚'}, 
    '184': {'name': '手引きの十字', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択したマジックを基礎CPの1/10増加したCPで設置'}, 
    '185': {'name': '魔人の手引き', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択した魔人種族ユニットを基礎CPの2/10を減算したCPで召喚'}, 
    '186': {'name': '魔物の手引き', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択した魔物種族ユニットを基礎CPの2/10を減算したCPで召喚'}, 
    '187': {'name': '竜の手引き', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択した竜種族ユニットを基礎CPの2/10を減算したCPで召喚'}, 
    '188': {'name': '天使の手引き', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択した天使種族ユニットを基礎CPの2/10を減算したCPで召喚'}, 
    '189': {'name': '悪魔の手引き', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択した悪魔種族ユニットを基礎CPの2/10を減算したCPで召喚'}, 
    '190': {'name': '神の手引き', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分の手札から選択した神種族ユニットを基礎CPの2/10を減算したCPで召喚'}, 
    '191': {'name': '火界呪', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '選択した相手のLP を『自分の場のユニットの合計AP÷2』減少 ※場の属性が「火」の時に発動可能'}, 
    '192': {'name': '水界呪', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '選択した相手のMPを『自分の場のユニットの合計AP÷10』減少 ※場の属性が「水」の時に発動可能'}, 
    '193': {'name': '地界呪', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のLPを『自分の場のユニットの合計DP』回復 ※場の属性が「地」の時に発動可能'}, 
    '194': {'name': '天界呪', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のMPを『自分の場のユニットの合計DP÷10』回復 ※場の属性が「天」の時に発動可能'}, 
    '195': {'name': '光界呪', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分は『自分の場のユニットのCP÷50』枚ドロー ※場の属性が「光」の時に発動可能'}, 
    '196': {'name': '闇界呪', 'category': 'マジック', 'type': '単発', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '選択した相手の手札の左側の『自分の場のユニットのCP÷50』枚を墓地に送る ※場の属性が「闇」の時に発動可能'}, 
    '197': {'name': '防御攻撃の極意', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のユニットは守備表示のまま攻撃できる'}, 
    '198': {'name': '篭城作戦', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のターン開始毎に自分の場の守備表示ユニットのDP1200につき自分のLP+500'}, 
    '199': {'name': '兵糧攻め', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のターン開始毎に自分の場の守備表示ユニットのDP1200につき相手のLP-250'}, 
    '200': {'name': '補給作戦', 'category': 'マジッ ク', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のターン開始毎に自分の場の守備表示ユニットのDP1200につき自分のMP+50'}, 
    '201': {'name': '水攻め', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のターン開始毎に自分の場の守備表示ユニットのDP1200につき相手のMP-25'}, 
    '202': {'name': '回復の魔法陣', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のLPが増加する時、自分のLPを更に+500'}, 
    '203': {'name': '追撃の魔法陣', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '相手のLPが減少する時、相手のLPを更に-250'}, 
    '204': {'name': 'ユグドラシルの葉', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のLPが回復する毎に回復したLP÷10の値で自分のMPを回復 ※重複効果なし'}, 
    '205': {'name': '背水の陣', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のドローフェイズに自分のLPが低いほどMPを回復(LP+4500以下でMP+25、LP3000以下でMP+50、LP1500以下でMP+75) ※重複効果なし'}, 
    '206': {'name': '水柱の篭手', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のドローフェイズにドロー可能な枚数が1枚増加 ※重複効果なし'}, 
    '207': {'name': '心核の篭手', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '自分のドロー毎に自分のLP+500 ※重複効果なし'}, 
    '208': {'name': '八卦の篭手', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '200', 'ap': '', 'dp': '', 'effect': '自分のドロー毎に自分のMP+50 ※重複効果なし'}, 
    '209': {'name': '桜花の篭手', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のドロー毎に自分のLP+500 ※重複効果なし ※自分のターン開始時に表側表示になっていると破壊'}, 
    '210': {'name': '四象の篭手', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のドロー毎に自分のMP+50 ※重複効果なし ※自分のターン開始時に表側表示になっていると破壊'}, 
    '211': {'name': '聖なる壁', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分の場のユニットの戦闘を無効化 ※自分のターン開始時に表側表示になっていると破壊'}, 
    '212': {'name': '絶対防御', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分へのLPダメージを無効化 ※自分のターン開始時に表側表示になってい ると破壊'}, 
    '213': {'name': '火力アップ', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のターン開始毎に自分の場のユニットの基礎AP・基礎DP+300 ※重複効果なし ※場の属性が「火」の時に発動可能'}, 
    '214': {'name': '防波堤', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のユニットが召喚される時、基礎APを全て基礎DPにする ※場の属性が「水」の時に発動可能'}, 
    '215': {'name': '大地の怒り', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のユニットが召喚される時、基礎DPの半分を基礎APにする ※場の属性が「地」の時に発動可能'}, 
    '216': {'name': '風の神殿', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分のドローフェイズに自分の場のユニットのCP÷100（小数点以下切捨て）枚を更にドロー ※重複効果なし ※場の属性が「天」の時に発動可能'}, 
    '217': {'name': '闘神の結界', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分のLPの減少が1/2減少する ※重複効果なし ※場の属性が「光」の時に発動可能'}, 
    '218': {'name': '魔力の結晶', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '250', 'ap': '', 'dp': '', 'effect': '自分の手札・墓地のカードのCPが基礎CPの1/2減少する ※重複効果なし ※場の属性が「闇」 の時に発動可能'}, 
    '219': {'name': '紅蓮の力', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '相手の場にユニットがいても、1/2のAPで直接攻撃可能 ※場の属性が「火」の時に発動可能'}, 
    '220': {'name': '水鏡の宝玉', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': '自分のユニットは基礎APと基礎DPを交換した状態になる ※場の属性が「水」の時に発動可能'}, 
    '221': {'name': '大地の加護', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分のユニ ットが破壊された時、CP×10のLPを消費し、破壊されたユニットを場に残す ※場の属性が「地」の時に発動可能'}, 
    '222': {'name': '風神の吐息', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のターン開始時に攻撃表示に、自分のターン終了時に守備表示になる ※場の属性が「天」の時に発動可能'}, 
    '223': {'name': '戦神の恵み', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '自分のターン開始時に手札の左側の1枚を墓地に送り、自分のMP+50 ※重複効果なし ※場の属性が「光」の時に発動可能'}, 
    '224': {'name': '冥府の泉', 'category': 'マジック', 'type': '継続', 'attribute': '', 'cp': '0', 'ap': '', 'dp': '', 'effect': 'この魔法の前方にユニットが召喚される時、基礎CP分のMPを回復して基礎CP×10のLPを消費 ※場の属性が「闇」の時に発動可能'}, 
    '225': {'name': 'LPドレイン', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが戦闘で敵を破壊 する毎に破壊した敵のCP×10の値で自分のLPを回復 ※重複効果なし'}, 
    '226': {'name': 'MPドレイン', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが戦闘で敵を破壊する毎に破壊した敵のCPの値で自分のMPを回復 ※重複効果なし'}, 
    '227': {'name': '手札ドレイン', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが戦闘で敵を破壊する毎に破壊した敵のCP÷50の枚数をドロー ※重複効果なし'}, 
    '228': {'name': 'パラドレイン', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが戦闘で敵を破壊する毎に破壊した敵のCP×2の値を装備したユニットの基礎AP・基礎DPに加算 ※重複効果なし'}, 
    '229': {'name': '現世の鎖', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '150', 'ap': '', 'dp': '', 'effect': '装備したユニットが破壊された時、代わりにこのマジックが破壊される ※2枚以上装備時は1枚のみ破壊'}, 
    '230': {'name': '自動制御装置', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットは自分のターン開始時に攻撃表示に、自分のターン終了時に守備表示になる'}, 
    '231': {'name': 'エナジーブレード', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットはLPが高いほどAP・DPが増加（LP1000につきAP・DP+100）'}, 
    '232': {'name': 'ウインドランス', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットは手札が多いほどAP・DPが増加（手札1枚につきAP・DP+100）'}, 
    '233': {'name': '対価の剣', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備した瞬間、自分のLPを3000消費 し、装備したユニットのAP・DP+800'}, 
    '234': {'name': '集約の槍', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備した瞬間、装備したユニット以外の自分の場のユニットを破壊し、破壊したユニットの基礎AP・基礎DPを装備したユニットに加算'}, 
    '235': {'name': '特攻の剣', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットを戦闘で破壊した敵を破壊する'}, 
    '236': {'name': '騎士の盾', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットのDP+500'}, 
    '237': {'name': 'LP抽出の力', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが破壊された時、破壊されたユ ニットの操作者は破壊されたユニットのCP×5のLPを回復 ※自身以外の装備魔法のCP含む'}, 
    '238': {'name': 'MP抽出の力', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが破壊された時、破壊されたユニットの操作者は破壊されたユニットのCP÷2のMPを回復 ※自身以外の装備魔法のCP含む'}, 
    '239': {'name': '手札抽出の力', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '装備したユニットが破壊された時、破壊されたユニットの操作者は破壊されたユニットのCP÷100（小数点以下切り上げ）の枚数をドロー ※自身以外の装備魔法のCP含む'}, 
    '240': {'name': '戦士の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+300・DP+300'}, 
    '241': {'name': '魔人の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+400・DP+400 ※魔人種族専用'}, 
    '242': {'name': '魔物の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+400・DP+400 ※魔物種族専用'}, 
    '243': {'name': '竜の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+400・DP+400 ※竜種族専用'}, 
    '244': {'name': '天使の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+400・DP+400 ※天使種族専用'}, 
    '245': {'name': '悪魔の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+400・DP+400 ※悪魔種族専用'}, 
    '246': {'name': '神の武具', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '装備したユニットのAP+400・DP+400 ※神種族専用'}, 
    '247': {'name': '戦士の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の墓地のユニットの数×75＋150を装備したユニットのAP・DPに加算'}, 
    '248': {'name': '魔人の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の墓地の魔人種族ユニットの数×100＋200を装備したユニットのAP・DPに加算 ※魔人種族専用'}, 
    '249': {'name': '魔物の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の墓地の魔物種族ユニットの数×100＋200を装備したユニットのAP・DPに加算 ※魔物種族専用'}, 
    '250': {'name': '竜の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の手札の竜種族ユニットの数×150＋100を装備したユニットのAP・DPに加算 ※竜種族専用'}, 
    '251': {'name': '天使の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の手札の天使種族ユニットの数×150＋100を装備したユニットのAP・DPに加算 ※天使種族専用'}, 
    '252': {'name': '悪魔の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の墓地の悪魔種族ユニットの数×100＋200を装備したユニットのAP・DPに加算 ※悪魔種族専用'}, 
    '253': {'name': '神の施し', 'category': 'マジック', 'type': '装備', 'attribute': '', 'cp': '100', 'ap': '', 'dp': '', 'effect': '自分の手札の神種族ユニットの数×150＋100を装備したユニットのAP・DPに加算 ※神種 族専用'}, 
    '254': {'name': '決闘場', 'category': 'マジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「決闘場」に変更し、属性による能力変化を排除する'}, 
    '255': {'name': '火の領域', 'category': 'マジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「火」に変更し、火属性ユニットのAP・DP+100'}, 
    '256': {'name': '水の領域', 'category': 'マジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「水」に変更し、水属性ユニットのAP・DP+100'}, 
    '257': {'name': '地の領域', 'category': 'マジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「地」に変更し、地属性ユニットのAP・DP+100'}, 
    '258': {'name': '天の領域', 'category': 'マ ジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「天」に変更し、天属性ユニットのAP・DP+100'}, 
    '259': {'name': '光の領域', 'category': 'マジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「光」に変更し、光属性ユニットのAP・DP+100'}, 
    '260': {'name': '闇の領域', 'category': 'マジック', 'type': '属性', 'attribute': '', 'cp': '50', 'ap': '', 'dp': '', 'effect': '場の領域を「闇」に変更し、闇属性ユニットのAP・DP+100'}
}

/* デッキを表すクラス */
class Deck {
    content; // 各カードの枚数の配列
    size; // 枚数
    deckcode; // デッキコード

    constructor() {
        this.content = [];
        for (let i=0 ; i<260 ; i++) {
            this.content[i] = 0;
        }
        this.size = 0;
        this.deckcode = "";
    }

    /*
        文字列をデッキコードとして登録（読み込みは行わない）
        @param str デッキコード
    */
    setDeckCode(_deckcode) {
        this.deckcode = _deckcode;
    }

    /*
        カードを追加する
        @param id カードNo.
        @param num 枚数（省略の場合は1枚）
    */
    setCard(id, num=1) {
        if (id <= 0 || id > 260) {
            return;
        }
        if (this.size >= 40) {
            return;
        }
        // 1枚追加をnum回行う
        for (let i=0 ; i<num ; i++) {
            if (this.content[id-1] < 3) {
                this.content[id-1] += 1;
                this.size += 1;
            }
        }
        return;
    }

    /*
        デッキに含まれているカードIDを配列で取得する
        @param sorted 並べ替えを行うかどうか (true: 表示順 false: ID順)
        @return カードIDの配列
    */
    getCardList(sort=true) {
        let content_sorted = [];
        // console.log("カード一覧(ベクトル表記): " + this.content);

        // ベクトル形式をカードIDリスト形式に変換
        for (let i=0 ; i<260 ; i++) {
            if (this.content[i] > 0) {
                for (let j=0 ; j<this.content[i] ; j++) {
                    content_sorted.push(i + 1);
                }
            }
        }

        if (sort) {
            // 並べ替え用比較関数
            let comp = function(card1, card2) {
                if ((card_dict[card1].category == 'ユニット') && (card_dict[card2].category == 'ユニット')) {
                    // ユニット同士では、CPが小さい順に並べ替える
                    if (card_dict[card1].cp == card_dict[card2].cp) {
                        // CPが同じ場合、カードID順に並び替える
                        return card1 - card2;
                    } else {
                        return card_dict[card1].cp - card_dict[card2].cp;
                    }
                } else {
                    // ユニット同士以外では、カードID順に並び替える
                    return card1 - card2;
                }
            };
            // ソート実行
            content_sorted.sort(comp);
            // console.log("ソート結果: " + content_sorted);
            return content_sorted;
        } else {
            return content_sorted;
        }
    }

    /*
        デッキの中身をベクトル表記で返す
        @param sep 区切り文字
        @return デッキのベクトル表示（テキスト形式）
    */
    getVector(sep=',') {
        let vectorText = '';
        for (let i=0 ; i<260 ; i++) {
            vectorText = vectorText + this.content[i];
            if (i+1 < 260) {
                vectorText = vectorText + sep;
            }
        }
        return vectorText;
    }

    /*
        デッキの中身をテキストで返す
    */
    toString(useHTML=false) {
        let out_text = "";
        let unit_text = "";
        let magic_text = "";
        let unit_count = 0;
        let magic_count = 0;

        let cardList = this.getCardList(true);
        let newLine = "\n";
        if (useHTML) {
            newLine = "<br>";
        }
        let cardCount = 1;

        for (let i=0 ; i<cardList.length ; i++) {
            // カードIDを3桁に成形
            let cardIdText = '';
            let id = cardList[i];
            if (id < 10) {
                cardIdText = "00" + id;
            } else if (id < 100) {
                cardIdText = "0" + id;
            } else {
                cardIdText = "" + id;
            }

            if ((i==cardList.length-1) || (id!=cardList[i+1])) {
                if (card_dict[id].category == "ユニット") {
                    unit_text = unit_text + "No" + cardIdText + " " + card_dict[id].name + " × " + cardCount + newLine;
                    unit_count += cardCount;
                } else if (card_dict[id].category == "マジック") {
                    magic_text = magic_text + "No" + cardIdText + " " + card_dict[id].name + " × " + cardCount + newLine;
                    magic_count += cardCount;
                }
                cardCount = 1;
            } else {
                cardCount += 1;
            }
        }
        out_text = "[デッキコード]" + newLine + this.deckcode + newLine + newLine
                    + "[ユニット] × " + unit_count + newLine + unit_text + newLine
                    + "[マジック] × " + magic_count + newLine + magic_text + newLine;
        return out_text;
    }

    /*
        デッキの中身をHTMLで返す
        TODO デッキコード表示の表記と合わせる
    */
    toHTML() {
        let out_text = this.toString(true);
        return out_text;
    }

    /*
        ユニット枚数を返す
    */
    getUnitSize() {
        let count = 0;
        for (let i=0 ; i<260 ; i++) {
            if (this.content[i] > 0) {
                if (card_dict[i+1]['category'] == 'ユニット') {
                    count += this.content[i];
                }
            }
        }
        return count;
    }

    /*
        マジック枚数を返す
    */
    getMagicSize() {
        return 40 - this.getUnitSize();
    }

    /*
        合計CPを返す
    */
    getTotalCP() {
        let total = 0;
        for (let i=0 ; i<260 ; i++) {
            if (this.content[i] > 0) {
                let card_cp = parseInt(card_dict[i+1]['cp'])
                total += card_cp * this.content[i];
            }
        }
        return total;
    }

    /*
        合計作成コストを返す（神を除く）
    */
    getTotalGold() {
        let total = 0;
        for (let i=0 ; i<260 ; i++) {
            if (this.content[i] > 0) {
                if (card_dict[i+1]['type'] == '神') {
                    continue;
                }
                let card_cp = parseInt(card_dict[i+1]['cp']);
                let card_gold = 0;
                if (card_cp == 0) {
                    card_gold = 200;
                } else if (card_cp == 50) {
                    card_gold = 200;
                } else if (card_cp == 100) {
                    card_gold = 300;
                } else if (card_cp == 150) {
                    card_gold = 500;
                } else if (card_cp == 200) {
                    card_gold = 700;
                } else if (card_cp == 250) {
                    card_gold = 1000;
                } else if (card_cp == 300) {
                    card_gold = 1500;
                }
                total += card_gold * this.content[i];
            }
        }
        return total;
    }
}

/* デッキコード関連処理を行うクラス */
class Deckcode {

    static codeElementToInt(element) {
        const codeElementDict = {
            "0" : 0,
            "1" : 1,
            "2" : 2,
            "3" : 3,
            "4" : 4,
            "5" : 5,
            "6" : 6,
            "7" : 7,
            "8" : 8,
            "9" : 9,
            "a" : 10,
            "b" : 11,
            "c" : 12,
            "d" : 13,
            "e" : 14,
            "f" : 15,
            "g" : 16,
            "h" : 17,
            "i" : 18,
            "j" : 19,
            "k" : 20,
            "l" : 21,
            "m" : 22,
            "n" : 23,
            "o" : 24,
            "p" : 25,
            "q" : 26,
            "r" : 27,
            "s" : 28,
            "t" : 29,
            "u" : 30,
            "v" : 31,
            "w" : 32,
            "x" : 33,
            "y" : 34,
            "z" : 35,
            "A" : 36,
            "B" : 37,
            "C" : 38,
            "D" : 39,
            "E" : 40,
            "F" : 41,
            "G" : 42,
            "H" : 43,
            "I" : 44,
            "J" : 45,
            "K" : 46,
            "L" : 47,
            "M" : 48,
            "N" : 49,
            "O" : 50,
            "P" : 51,
            "Q" : 52,
            "R" : 53,
            "S" : 54,
            "T" : 55,
            "U" : 56,
            "V" : 57,
            "W" : 58,
            "X" : 59,
            "Y" : 60,
            "Z" : 61,
        };
        const firstChar = element.charAt(0);
        const secondChar = element.charAt(1);
        return codeElementDict[firstChar] * 62 + codeElementDict[secondChar];
    }

    /* 
        デッキコードを読み込み、Deckオブジェクトを返す関数
        @param code デッキコード(文字列)
    */
    static decode(code) {
        // 現在の読み取り位置
        let cursor = 0; 
        let deck = new Deck();
        deck.setDeckCode(code);

        // 1文字目が'1'でない場合エラー
        if (code.substr(cursor, 1) != '1') {
            return undefined;
        } else {
            cursor ++;

            while(true) {
                if (cursor + 1 >= code.length) {
                    break;
                }
                let codeElement = code.substr(cursor, 2);
                let codeElementValue = this.codeElementToInt(codeElement);

                const cardId = Math.floor(codeElementValue / 3) + 1;
                const cardNum = codeElementValue % 3 + 1;
                if (cardId > 260) {
                    cursor += 2;
                    continue;
                }
                deck.setCard(cardId, cardNum);
                cursor += 2;
            }
            return deck;
        }
    }
}